#undef HAVE_CONFIG_H
#include <map>
#include <string>
//#include <iostream>
#include "async.h"
#include "http.h"

#define DEF_PORT 8999
#define MAX_CONN 10


struct cacheEntry {
	strbuf 		had;	//the head in a string
	strbuf 		con;	//the content in a string
  	time_t		date;
  	time_t		expires;
  	time_t		last_modified;
};

typedef std::map< std::string, cacheEntry*, std::less<std::string>  > type_Cache;
type_Cache gCache;

struct connx {

	int 		cs;						//client socket
	int 		ss;						//server socket
	bool 		cs_sent_headers;		//headers already forwarded to client?
	bool 		cs_send_from_cache;		//send from cache?
	int 		fwed;					//total size forwarded
	
	strbuf 		buf;					//buffer for all kinds of data
		
	httpreq		req;					//the request parser
	httpresp	resp;					//the response parser
	
	cacheEntry  *ce;					//the entry that gets entered into the cache
	
	connx() 
		: fwed(0), cs (0), ss (0),
		cs_sent_headers(false), cs_send_from_cache(false), ce(NULL) {};
	~connx(){
		close(cs);
		close(ss);
	}
	
};

void cs_accept_connection(int fd);
void cs_read_ready(connx *cx);
void cs_write_ready(connx *cx);

void ss_connected(connx *cx, int newSock);
void ss_write_ready(connx *cx);
void ss_read_ready(connx *cx);

